fixed x restarting, last commit fixed a bug that didnt exist in that way...
[pandora-libraries.git] / testdata / scripts / pnd_run.sh
1 #!/bin/bash
2  
3 #Usage: pnd_run.sh -p your.pnd -e executeable [-a "(arguments)"] [ -s "cd to folder inside pnd"] [-b UID (name of mountpoint/pandora/appdata)] [-x close x before launching(script needs to be started with nohup for this to work]
4 # -s startdir
5 # arguments can be inside -e, -a is optional
6  
7 #/etc/sudoers needs to be adjusted if you touch any of the sudo lines
8  
9 # look at the comments in the nox part, adjust 
10  
11 #use "lsof /usr/lib/libX11.so.6 | awk '{print $1}'| sort | uniq > whitelist" with nothing running to generate the whitelist
12  
13 #launch the script with nohup for -x to work!
14  
15 #todo
16 #validate params better
17 #make uid/basename mandatory (and rename var, its confusing!)
18 #find a clean way of shutting down x without a fixed dm, mabye avoid nohup usage somehow
19 #cleanup
20  
21 # parse arguments
22 TEMP=`getopt -o p:e:a:b:s:m::u::n::x::j: -- "$@"`
23  
24 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
25  
26 # Note the quotes around `$TEMP': they are essential!
27 eval set -- "$TEMP"
28  
29 while true ; do
30         case "$1" in
31                 -p) echo "pnd set to \`$2'" ;PND=$2;shift 2;;
32                 -e) echo "exec set to \`$2'" ;EXENAME=$2;shift 2 ;;
33 #               -n) echo "n set, no union pls!";NOUNION=1;shift 2;; # we will reuse -n soon,stop using it if you still did!
34                 -b) echo "BASENAME set to $2";BASENAME=$2;shift 2;;
35                 -s) echo "startdir set to $2";STARTDIR=$2;shift 2;;
36                 -m) echo "mount";mount=1;shift 2;;
37                 -u) echo "umount";umount=1;shift 2;;
38                 -x) echo "no x";nox=1;shift 2;;
39                 -j) echo "join/ also mount those folders";append=$2;shift 2;;
40                 -a) 
41                         case "$2" in
42                                 "") echo "no arguments"; shift 2 ;;
43                                 *)  echo "args set to \`$2'" ;ARGUMENTS=$2;shift 2 ;;
44                         esac ;;
45                 --) shift ; break ;;
46                 *) echo "Error while parsing arguments!" ; exit 1 ;;
47         esac
48 done
49  
50 if [ ! $PND ]; then #check if theres a pnd suplied, need to clean that up a bit more
51         echo "Usage: pnd_run.sh -p your.pnd -e executeable [-a \"(arguments)\"] [ -s \"cd to folder inside pnd\"] [-b UID (name of mountpoint/pandora/appdata)] [-x close x before launching(script needs to be started with nohup for this to work]"
52         exit 1
53 fi
54 if [ ! $EXENAME ]; then
55         if [ ! $mount ] && [ ! $umount ]; then
56                 echo "Usage: pnd_run.sh -p your.pnd -e executeable [-a \"(arguments)\"] [ -s \"cd to folder inside pnd\"] [-b UID (name of mountpoint/pandora/appdata)] [-x close x before launching(script needs to be started with nohup for this to work]"
57                 echo "Usage for mounting/umounting pnd_run.sh -p your.pnd -b uid -m or -u"
58                 exit 1
59         fi
60 fi
61
62 fork () {
63 echo in fork!
64 if [ $nox ]; then #the app doesnt want x to run, so we kill it and restart it once the app quits
65         applist=$(lsof /usr/lib/libX11.so.6 | awk '{print $1}'| sort | uniq)
66         whitelist=$(cat ~/pndtest/whitelist) #adjust this to a fixed whitelist, maybe in the config dir
67         filteredlist=$(echo -e "$applist\n\n$whitelist\n\n$whitelist" | sort | uniq -u) #whitelist appended two times so those items are always removed
68         if [ ${#filteredlist} -ge 1 ]; then
69                 message=$(echo -e "The following applications are still running, are you sure you want to close x? \n$filteredlist")
70                 echo -e “ae[34me[30m”
71                 xmessage -center "$message", -buttons yes,no
72                 if [ $? = 102 ]; then
73                 exit 1
74                 fi
75                 sudo /etc/init.d/slim-init stop
76                 sleep 5s
77         else
78                 echo -e “ae[34me[30m”
79                 xmessage -center "killing x, nothing of value will be lost", -buttons ok,cancel
80                 if [ $? = 102 ]; then
81                 exit 1
82                 fi
83                 # close x now, do we want to use slim stop or just kill x?
84                 sudo /etc/init.d/slim-init stop
85                 sleep 5s
86         fi
87 fi
88  
89 #vars
90 DFS=$(file -b $PND | awk '{ print $1 }') #is -p a zip/iso or folder?
91 MOUNTPOINT=$(df $PND | sed -ne 's/.*\% \(\S*\)/\1/p' | tail -n1) #find out on which mountpoint the pnd is
92 if [ ! -d "$MOUNTPOINT" ]; then MOUNTPOINT="/"; fi #make sure folder exists, if it doesnt assume rootfs
93 FILESYSTEM=$(mount | grep "on $MOUNTPOINT " | grep -v rootfs | awk '{print $5}' | tail -n1) #get filesystem appdata is on to determine aufs options
94 echo "Filesystem is $FILESYSTEM"
95 #if the pnd is on / set mountpoint to "" so we dont and up with // at the start,
96 #this is to make sure sudo doesnt get confused
97 if [ $MOUNTPOINT = "/" ]; then MOUNTPOINT=""; fi
98 echo "mountpoint: $MOUNTPOINT"
99  
100 #BASENAME really should be something sensible and somewhat unique
101 #if -b is set use that as basename, else generate it from PND
102 #get basename (strip extension if file) for union mountpoints etc, maybe  this should be changed to something specified inside the xml
103 #this should probably be changed to .... something more sensible
104 if [ ! $BASENAME ]; then BASENAME=$(basename "$PND" | cut -d'.' -f1) ; fi
105  
106  
107  
108 oCWD=$(pwd)
109
110
111  
112 #create mountpoints, check if they exist already first to avoid annoying error messages
113 if [ ! -d /mnt/pnd/$BASENAME ]; then sudo mkdir -p /mnt/pnd/$BASENAME ; fi #mountpoint for iso, ro
114 #writeable dir for union
115 if [ ! -d $MOUNTPOINT/pandora/appdata/$BASENAME ]; then sudo mkdir -p $MOUNTPOINT/pandora/appdata/$BASENAME; sudo chmod -R a+xrw $MOUNTPOINT/pandora/appdata/$BASENAME; fi
116 if [ ! -d /mnt/utmp/$BASENAME ]; then sudo mkdir -p /mnt/utmp/$BASENAME; fi #union over the two
117
118 #mount
119  
120 if [ ! $umount ]; then
121         #is the union already mounted? if not mount evrything, else launch the stuff
122         mount | grep "on /mnt/utmp/$BASENAME type" # > /dev/null
123         if [ ! $? -eq 0 ]; then 
124
125           FREELOOP=$(sudo /sbin/losetup -f) #get first free loop device
126           if [ ! $FREELOOP  ]; then  # no free loop device, create a new one
127                   #find a free loop device and use it 
128                   usedminor=$(sudo /sbin/losetup -a | tail -n1)
129                   usedminor=${usedminor:9:1}
130                   echo usedminor $usedminor
131                   freeminor=$(($usedminor+1))
132                   echo freeminor $freeminor
133                   sudo mknod -m777 /dev/loop$freeminor b 7 $freeminor
134                   FREELOOP=/dev/loop$freeminor
135           fi
136           
137           #detect fs
138           if [ $DFS = ISO ]; then
139                   sudo /sbin/losetup $FREELOOP $PND #attach the pnd to the loop device
140                   mntline="sudo mount $FREELOOP /mnt/pnd/$BASENAME/" #setup the mountline for later
141           #     mntline="sudo mount -o loop,mode=777 $PND /mnt/pnd/$BASENAME"
142                   echo "Filetype is $DFS"
143           elif [ $DFS = directory ]; then
144                   mntline="sudo mount --bind -o ro $PND /mnt/pnd/$BASENAME"
145           #we bind the folder, now it can be treated in a unified way ATENTION: -o ro doesnt work for --bind at least on 25, on 26 its possible using remount, may have changed on 27
146                   echo "Filetype is $DFS"
147           elif [ $DFS = Squashfs ]; then
148                   sudo /sbin/losetup $FREELOOP $PND #attach the pnd to the loop device
149                   mntline="sudo mount -t squashfs  $FREELOOP /mnt/pnd/$BASENAME"
150                   echo "Filetype is $DFS"
151           else
152                   echo "error determining fs, output was $DFS"
153                   exit 1;
154           fi
155
156
157                 echo "$mntline"
158                 $mntline #mount the pnd/folder
159                 echo "mounting union!"
160                 if [ $FILESYSTEM = vfat ]; then # use noplink on fat, dont on other fs's 
161                 #append is fucking dirty, need to clean that up
162                 sudo mount -t aufs -o exec,noplink,dirs=$MOUNTPOINT/pandora/appdata/$BASENAME=rw+nolwh:/mnt/pnd/$BASENAME=rr$append none /mnt/utmp/$BASENAME # put union on top
163                 else
164                 sudo mount -t aufs -o exec,dirs=$MOUNTPOINT/pandora/appdata/$BASENAME=rw+nolwh:/mnt/pnd/$BASENAME=rr$append none /mnt/utmp/$BASENAME # put union on top
165                 fi
166  
167         else
168                 echo "Union already mounted"
169         fi
170  
171         if [ $mount ]; then echo "mounted /mnt/utmp/$BASENAME"; exit 1; fi; #mount only, die here
172         
173         cd /mnt/utmp/$BASENAME # cd to union mount
174         if [ $STARTDIR ]; then cd $STARTDIR; fi #cd to folder specified by the optional arg -s
175         LD_LIBRARY_PATH=/mnt/utmp/$BASENAME ./$EXENAME $ARGUMENTS # execute app with ld_lib_path set to the union mount, a bit evil but i think its a good solution
176         #the app could have exited now, OR it went into bg, we still need to wait in that case till it really quits!
177         PID=`pidof -o %PPID -x $EXENAME` #get pid of app
178         while [ "$PID" ] #wait till we get no pid back for tha app, again a bit ugly, but it works
179         do
180         sleep 10s
181         PID=`pidof -o %PPID -x $EXENAME`
182         done
183         echo end
184  
185         #app exited
186         cd $oCWD #cd out of the mountpoint so we can umount, doesnt really matter to where...
187 else
188 echo "-u set, nothing to do here"
189 fi
190  
191  
192 #clean up
193 sudo umount /mnt/utmp/$BASENAME #umount union
194 if [ $? -eq 0 ]; then # check if the umount was successfull, if it wasnt it would mean that theres still something running so we skip this stuff, this WILL lead to clutter if it happens, so we should make damn sure it never happens
195         #umount the actual pnd
196         sudo umount /mnt/pnd/$BASENAME
197         #delete folders created by aufs if empty
198         sudo rmdir $MOUNTPOINT/pandora/appdata/$BASENAME/.wh..wh.plnk
199         sudo rmdir $MOUNTPOINT/pandora/appdata/$BASENAME/.wh..wh..tmp
200         #delete appdata folder and ancestors if empty
201         sudo rmdir -p $MOUNTPOINT/pandora/appdata/$BASENAME/
202         #delete tmp mountpoint
203         sudo rmdir /mnt/utmp/$BASENAME;
204         if [ $DFS = ISO ] || [ $DFS = Squashfs ]; then # check if we where running an iso, clean up loop device if we did
205                 sudo /sbin/losetup -d $FREELOOP
206                 sudo rm $FREELOOP
207         fi
208         sudo rmdir /mnt/pnd/$BASENAME #delete pnd mountpoint
209 fi
210
211 if [ $nox ]; then #restart x if it was killed
212 echo "starting x in 5s"
213 sleep 5
214 sudo /etc/init.d/slim-init start
215 fi
216 }
217 echo forking now!
218 fork &
219 disown